<template>
    <div>
        <div class="card bg-dark text-white p1 m-3" style="width: 20rem;">
            <h5>Search / Add name</h5>
            <input v-model="searchString" @keyup="searchForHero"/>
            <h5>Add imageUrl</h5>
            <input v-model="imageUrl">

            <button @click="addHero(searchString, imageUrl)" class="btn btn-outline-success">Add</button>
        </div>
        <div class="card bg-dark text-white m-3" style="width: 20rem;">
            <h3 class="card-title pt-2">{{title}}</h3>
            <div v-for="hero in results">
                <h3 class="d-flex justify-content-center">
                    <span class="badge badge-secondary row d-flex justify-content-center" style="width: 15rem">
                    <router-link :to="hero.id.toString()" class="pr-3">
                        <img :src="hero.imageUrl"
                             style="width: 40px; height: 60px; overflow: hidden; align-self: left"
                             class="rounded border border-black">
                        {{hero.name}}
                    </router-link>
                    <div @click="removeHero(hero.id)">
                        <i class="fas fa-trash-alt fa-xs"></i>
                    </div>
                    </span>
                </h3>
            </div>
        </div>
    </div>
</template>

<script>
    import heroDataService from './HeroDataService'
    import heroMessageService from './HeroMessageService.js'

    export default {
        data() {
            return {
                searchString: '',
                results: [],
                title: "Hero List",
                imageUrl: ''
            }
        },

        mounted() {
            this.searchForHero()
        },

        methods: {
            searchForHero() {
                this.results = heroDataService.getHeroesByName(this.searchString)
            },

            addHero(heroName, imageUrl) {
                heroDataService.addHero(heroName, imageUrl);
                heroMessageService.addLogEntry('Added hero "' + heroName + '"', this.title);
                this.searchForHero();
                heroMessageService.addLogEntry('Reloaded heroes', this.title);
            },

            removeHero(heroId) {
                let name = heroDataService.removeHero(heroId);
                heroMessageService.addLogEntry('Removed hero "' + name + '"', this.title);
                this.searchForHero();
                heroMessageService.addLogEntry('Reloaded heroes', this.title);
            }
        }
    }
</script>